-- package.seeall       __index, 
--    
module('ModuleLocker', package.seeall)

function lock(module)
  --     ,  ,
  --    __index  __newindex 
  --     t
  
  local serviceFields = {
    _NAME = true,
    _PACKAGE = true,
    _M = true,
  }
  
  local t = {}
  
  for k, v in pairs(module) do
    if not serviceFields[k] then
      t[k] = v
      
      --    
      rawset(module, k, nil)
    end
  end
  
  --       
  rawset(module, 'privateData_', t)
  
  local meta = {
    __index = function(t, k)
      --     
      return t.privateData_[k]
    end,
    
    __newindex = function(t, k, v)
      --  
      error('access denied!')
    end,    
  }
  
  setmetatable(module, meta)
end

function setValue(module, key, value)
  module.privateData_[key] = value
end